# Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.

# no debuggable binaries here
%define debug_package %{nil}
BuildArchitectures: noarch

# Version
%define ver_major 14
%define ver_minor 2
%define ver_patch 1
%define ver_release 1

Summary:        Vespa meta-package for gcc-toolset
Name:           vespa-toolset-%{ver_major}-meta
Version:        %{ver_major}.%{ver_minor}.%{ver_patch}
Release:        %{ver_release}%{?dist}
License:        Apache
URL:            https://vespa.ai/
Patch0:         patch.gthr-default.h.diff
Patch1:         patch.stl_vector.h.diff

%if 0%{?el8}%{?el9}
Requires: gcc-toolset-%{ver_major}-gcc-c++
Requires: gcc-toolset-%{ver_major}-annobin-plugin-gcc
%define _devtoolset_enable /opt/rh/gcc-toolset-%{ver_major}/enable
%endif

%global _vespa_3rdparty_deps_packaging_notice \
See https://github.com/vespa-engine/vespa-3rdparty-deps for details \
about packaging.

%description
Meta-package for required gcc-toolset packages and fixups.
%{_vespa_3rdparty_deps_packaging_notice}

%global mydir %{_prefix}/share/toolset-meta
%install
mkdir -p %{buildroot}%{mydir}
cp -a %{_sourcedir}/patch.gthr-default.h.diff %{buildroot}%{mydir}
cp -a %{_sourcedir}/patch.stl_vector.h.diff   %{buildroot}%{mydir}

%files
%{mydir}

%post
%if 0%{?_devtoolset_enable:1}
source %{_devtoolset_enable}
lgcf=`gcc -print-libgcc-file-name`
libdir=${lgcf%/libgcc.*}
plugindir=${libdir}/plugin
cd $plugindir && test -f annobin.so && ln -sf annobin.so gcc-annobin.so
vernum=${libdir##*/}
parentdir=${libdir%/*}
triple=${parentdir##*/}
rootdir=${parentdir%/lib/gcc/*}
incdir=${rootdir}/include/c++/${vernum}
cd ${incdir} || exit 1
cat %{mydir}/patch.stl_vector.h.diff | patch -p0 -r -
cd ${triple} || exit 1
cat %{mydir}/patch.gthr-default.h.diff | patch -p0 -r -
ln -sf $(dirname %{_devtoolset_enable}) /opt/rh/gcc-toolset
printf '%s\n'  "# gcc"  "source /opt/rh/gcc-toolset/enable"  > /etc/profile.d/enable-gcc-toolset.sh
%endif

%changelog
